#ifndef TRANSFORMER__H
#define TRANSFORMER__H

#include <torch/torch.h>
#include "MyModule.hpp"

class TransformerEncoderLayerImpl : public torch::nn::Module
{
  private :

  int inputSize;
  int hiddenSize;
  int numHeads;
  float dropoutValue;

  torch::nn::MultiheadAttention attention{nullptr};
  torch::nn::Linear linear1{nullptr}, linear2{nullptr};
  torch::nn::Dropout dropout{nullptr}, dropout1{nullptr}, dropout2{nullptr};
  torch::nn::LayerNorm layerNorm1{nullptr};
  torch::nn::LayerNorm layerNorm2{nullptr};

  public :

  TransformerEncoderLayerImpl(int inputSize, int hiddenSize, int numHead, float dropoutValue);
  torch::Tensor forward(torch::Tensor input);
};
TORCH_MODULE(TransformerEncoderLayer);

class TransformerImpl : public MyModule
{
  private :

  int inputSize;
  TransformerEncoderLayer encoder{nullptr};

  public :

  TransformerImpl(int inputSize, int hiddenSize, ModuleOptions options);
  torch::Tensor forward(torch::Tensor input);
  int getOutputSize(int sequenceLength);
};
TORCH_MODULE(Transformer);

#endif

